From 8c0849a4f268b3f2fc6fd0d0d4ebf830583bbfd7 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:24:38 +0000
Subject: [PATCH 805/2232] Keep target dir in Project struct


We'll put the OUT_DIR in here as well, to reduce the amount of code that
needs to be fallible.

---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 111f592..02df064 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -98,39 +98,51 @@ pub fn bridges(rust_source_files: impl IntoIterator<Item = impl AsRef<Path>>) ->
     })
 }
 
+struct Project {
+    target_dir: TargetDir,
+}
+
+impl Project {
+    fn init() -> Self {
+        Project {
+            target_dir: match cargo::target_dir() {
+                target_dir @ TargetDir::Path(_) => target_dir,
+                // Fallback if Cargo did not work.
+                TargetDir::Unknown => paths::search_parents_for_target_dir(),
+            },
+        }
+    }
+}
+
 fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Result<Build> {
-    let ref target_dir = target_dir();
-    let mut build = paths::cc_build(target_dir);
+    let ref prj = Project::init();
+    let mut build = paths::cc_build(prj);
     build.cpp(true);
     build.cpp_link_stdlib(None); // linked via link-cplusplus crate
-    write_header(target_dir);
+    write_header(prj);
 
     for path in rust_source_files {
-        generate_bridge(&mut build, path.as_ref(), target_dir)?;
+        generate_bridge(prj, &mut build, path.as_ref())?;
     }
 
     Ok(build)
 }
 
-fn write_header(target_dir: &TargetDir) {
-    let ref cxx_h = paths::include_dir(target_dir).join("rust").join("cxx.h");
+fn write_header(prj: &Project) {
+    let ref cxx_h = paths::include_dir(prj).join("rust").join("cxx.h");
     let _ = write(cxx_h, gen::include::HEADER.as_bytes());
 }
 
-fn generate_bridge(
-    build: &mut Build,
-    rust_source_file: &Path,
-    target_dir: &TargetDir,
-) -> Result<()> {
+fn generate_bridge(prj: &Project, build: &mut Build, rust_source_file: &Path) -> Result<()> {
     let opt = Opt::default();
     let generated = gen::generate_from_path(rust_source_file, &opt);
 
-    let header_path = paths::out_with_extension(rust_source_file, ".h", target_dir)?;
+    let header_path = paths::out_with_extension(prj, rust_source_file, ".h")?;
     fs::create_dir_all(header_path.parent().unwrap())?;
     write(&header_path, &generated.header)?;
-    paths::symlink_header(&header_path, rust_source_file, target_dir);
+    paths::symlink_header(prj, &header_path, rust_source_file);
 
-    let implementation_path = paths::out_with_extension(rust_source_file, ".cc", target_dir)?;
+    let implementation_path = paths::out_with_extension(prj, rust_source_file, ".cc")?;
     write(&implementation_path, &generated.implementation)?;
     build.file(&implementation_path);
     Ok(())
@@ -151,11 +163,3 @@ fn write(path: &Path, content: &[u8]) -> Result<()> {
     fs::write(path, content)?;
     Ok(())
 }
-
-fn target_dir() -> TargetDir {
-    match cargo::target_dir() {
-        target_dir @ TargetDir::Path(_) => target_dir,
-        // Fallback if Cargo did not work.
-        TargetDir::Unknown => paths::search_parents_for_target_dir(),
-    }
-}
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index 1814f82..45df2a5 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -1,5 +1,6 @@
 use crate::error::{Error, Result};
 use crate::gen::fs;
+use crate::Project;
 use std::env;
 use std::path::{Path, PathBuf};
 
@@ -14,10 +15,10 @@ fn out_dir() -> Result<PathBuf> {
         .ok_or(Error::MissingOutDir)
 }
 
-pub(crate) fn cc_build(target_dir: &TargetDir) -> cc::Build {
+pub(crate) fn cc_build(prj: &Project) -> cc::Build {
     let mut build = cc::Build::new();
-    build.include(include_dir(target_dir));
-    if let TargetDir::Path(target_dir) = target_dir {
+    build.include(include_dir(prj));
+    if let TargetDir::Path(target_dir) = &prj.target_dir {
         build.include(target_dir.parent().unwrap());
     }
     build
@@ -25,16 +26,16 @@ pub(crate) fn cc_build(target_dir: &TargetDir) -> cc::Build {
 
 // Symlink the header file into a predictable place. The header generated from
 // path/to/mod.rs gets linked to target/cxxbridge/path/to/mod.rs.h.
-pub(crate) fn symlink_header(path: &Path, original: &Path, target_dir: &TargetDir) {
-    if let TargetDir::Unknown = target_dir {
+pub(crate) fn symlink_header(prj: &Project, path: &Path, original: &Path) {
+    if let TargetDir::Unknown = prj.target_dir {
         return;
     }
-    let _ = try_symlink_header(path, original, target_dir);
+    let _ = try_symlink_header(prj, path, original);
 }
 
-fn try_symlink_header(path: &Path, original: &Path, target_dir: &TargetDir) -> Result<()> {
-    let suffix = relative_to_parent_of_target_dir(original, target_dir)?;
-    let ref dst = include_dir(target_dir).join(suffix);
+fn try_symlink_header(prj: &Project, path: &Path, original: &Path) -> Result<()> {
+    let suffix = relative_to_parent_of_target_dir(prj, original)?;
+    let ref dst = include_dir(prj).join(suffix);
 
     fs::create_dir_all(dst.parent().unwrap())?;
     let _ = fs::remove_file(dst);
@@ -48,8 +49,8 @@ fn try_symlink_header(path: &Path, original: &Path, target_dir: &TargetDir) -> R
     Ok(())
 }
 
-fn relative_to_parent_of_target_dir(original: &Path, target_dir: &TargetDir) -> Result<PathBuf> {
-    let mut outer = match target_dir {
+fn relative_to_parent_of_target_dir(prj: &Project, original: &Path) -> Result<PathBuf> {
+    let mut outer = match &prj.target_dir {
         TargetDir::Path(target_dir) => target_dir.parent().unwrap(),
         TargetDir::Unknown => unimplemented!(), // FIXME
     };
@@ -65,21 +66,17 @@ fn relative_to_parent_of_target_dir(original: &Path, target_dir: &TargetDir) -> 
     }
 }
 
-pub(crate) fn out_with_extension(
-    path: &Path,
-    ext: &str,
-    target_dir: &TargetDir,
-) -> Result<PathBuf> {
+pub(crate) fn out_with_extension(prj: &Project, path: &Path, ext: &str) -> Result<PathBuf> {
     let mut file_name = path.file_name().unwrap().to_owned();
     file_name.push(ext);
 
     let out_dir = out_dir()?;
-    let rel = relative_to_parent_of_target_dir(path, target_dir)?;
+    let rel = relative_to_parent_of_target_dir(prj, path)?;
     Ok(out_dir.join(rel).with_file_name(file_name))
 }
 
-pub(crate) fn include_dir(target_dir: &TargetDir) -> PathBuf {
-    match target_dir {
+pub(crate) fn include_dir(prj: &Project) -> PathBuf {
+    match &prj.target_dir {
         TargetDir::Path(target_dir) => target_dir.join("cxxbridge"),
         TargetDir::Unknown => out_dir().unwrap().join("cxxbridge"), // FIXME no unwrap
     }

